open Utils
open Format
open Lustre_types
open Machine_code_types
open C_backend_common

module type MODIFIERS_SRC = sig
  module GhostProto : MODIFIERS_GHOST_PROTO

  val pp_import_spec_prototype : formatter -> dep_t -> unit

  (* val pp_set_reset_spec : formatter -> machine_t list -> ident -> ident ->
     machine_t -> unit *)
  val pp_clear_reset_spec : formatter -> ident -> ident -> machine_t -> unit

  val pp_ghost_reset_spec :
    formatter -> machine_t list -> ident -> machine_t -> unit

  val pp_step_spec :
    formatter -> machine_t list -> ident -> ident -> machine_t -> unit

  val pp_step_instr_spec :
    machine_t -> ident -> ident -> formatter -> instr_t -> unit

  val pp_ghost_parameter : ident -> formatter -> ident option -> unit
  val pp_c_decl_local_spec_var : machine_t -> formatter -> var_decl -> unit
  val get_spec_locals : machine_t -> var_decl list

  (* val pp_ghost_reset_memory : machine_t -> formatter -> ident -> unit *)
  val pp_is_contract : (formatter -> unit) -> formatter -> unit
  val pp_contract_arrow_reset_name : formatter -> unit
  val pp_contract_arrow_step_name : formatter -> unit

  val pp_contract_step_call :
    machine_t ->
    (ident option * ident * var_decl list * var_decl list) option ->
    formatter ->
    unit ->
    unit

  (* val pp_ghost_reset: machine_t -> ident -> formatter -> unit -> unit *)
end

module EmptyMod : MODIFIERS_SRC

module Main (Mod : MODIFIERS_SRC) : sig
  val pp_lib_c :
    formatter -> string -> program_t -> machine_t list -> dep_t list -> unit

  val pp_ghost_reset_spec_code :
    machine_t list -> ident -> formatter -> machine_t -> unit
end
